using SurgeEngine.Actor;
using SurgeEngine.Behaviors.DirectionalMovement;
using SurgeEngine.Vector2;
using SurgeEngine.Collisions.CollisionBall;

object "Bee the Boss" is "entity", "boss", "awake"
{
    actor = Actor("Bee the Boss");
    movement = DirectionalMovement();
    collider = CollisionBall(30);
    restTime = 3; // given in seconds
    moveTime = 3; // given in seconds
    beeSpeed = 120; // given in pixels per second

    state "main"
    {
        collider.visible = true;
        state = "resting right";
    }

    state "resting right"
    {
        actor.hflip = true;
        movement.speed = 0;
        if(timeout(restTime)) { // after 3 seconds
            state = "moving left";
        }
    }

    state "moving left"
    {
        actor.hflip = true;
        movement.speed = beeSpeed;
        movement.direction = Vector2.left;
        if(timeout(moveTime)) {
            state = "resting left";
        }
    }

    state "resting left"
    {
        actor.hflip = false;
        movement.speed = 0;
        if(timeout(restTime)) {
            state = "moving right";
        }
    }

    state "moving right"
    {
        actor.hflip = false;
        movement.speed = beeSpeed;
        movement.direction = Vector2.right;
        if(timeout(moveTime)) {
            state = "resting right";
        }
    }

    fun onCollision(otherCollider)
    {
        entity = otherCollider.entity;
        if(entity.hasTag("player")) {
            player = entity;
            Console.print("COLLISION WITH THE PLAYER");
        }
    }
}
